local ret = ... or {}

ret.RedirTable = {
	Up = "Down",
	Down = "Down",
	Left = "Down",
	Right = "Down",
	UpLeft = "Down",
	UpRight = "Down"
}

local OldRedir = ret.Redir

ret.Redir = function(sButton, sElement)
	sButton, sElement = OldRedir(sButton, sElement)

	if (string.find(sElement, "Head") and not string.find(sElement, "Active")) or sElement == "Tap Fake" then
		sElement = "Tap Note"
	end
	if (not string.find(sElement, "Head") and not string.find(sElement, "Explosion") and not string.find(sElement, "Body") and not string.find(sElement, "Tail")) and (string.find(sElement, "Hold") or string.find(sElement, "Roll")) then
	else
		sButton = ret.RedirTable[sButton]
	end
	if string.find(sElement, "Head") and string.find(sElement, "Active") then
		sElement = "Tap Head"
	end

	return sButton, sElement
end

local OldFunc = ret.Load
function ret.Load()
	local t = OldFunc()

	-- The main "Explosion" part just loads other actors; don't rotate
	-- it.  The "Hold Explosion" part should not be rotated.
	if Var "Element" == "Explosion" or Var "Element" == "Roll Explosion" then
		t.BaseRotationZ = nil
	end
	--Use diffrent Holds/Rolls for every direction
	return t
end

ret.PartsToRotate = {
	["Receptor"] = true,
	["Tap Note"] = true,
	["Tap Fake"] = true,
	["Ready Receptor"] = true,
	["Tap Explosion Bright"] = true,
	["Tap Explosion Dim"] = true,
	["Hold Head Active"] = true,
	["Hold Head Inactive"] = true,
	["Roll Head Active"] = true,
	["Roll Head Inactive"] = true,
	["Tap Mine"] = true
}
ret.Rotate = {
	Up = 180,
	Down = 0,
	Left = 90,
	Right = -90,
	UpLeft = 135,
	UpRight = 225
}

ret.Blank = {
	["Hold Explosion"] = true,
	["Roll Explosion"] = true
}

return ret
